Index: trunk/Assembly_Library/Src/Display/CgaSnow.asm
===================================================================
--- trunk/Assembly_Library/Src/Display/CgaSnow.asm	(revision 202)
+++ trunk/Assembly_Library/Src/Display/CgaSnow.asm	(revision 223)
@@ -99,6 +99,5 @@
 	cli				; Interrupt request would mess up timing
 	WAIT_UNTIL_SAFE_CGA_WRITE
-	eSEG	es
-	movsb
+	es movsb
 	sti
 	loop	.MovsbNextByte
Index: trunk/Assembly_Library/Src/Display/DisplayFormat.asm
===================================================================
--- trunk/Assembly_Library/Src/Display/DisplayFormat.asm	(revision 202)
+++ trunk/Assembly_Library/Src/Display/DisplayFormat.asm	(revision 223)
@@ -92,6 +92,5 @@
 ALIGN JUMP_ALIGN
 ReadCharacterAndTestForNull:
-	eSEG	cs
-	lodsb									; Load from CS:SI to AL
+	cs lodsb								; Load from CS:SI to AL
 	test	al, al							; NULL to end string?
 	ret
@@ -321,5 +320,5 @@
 %endif
 
-ALIGN JUMP_ALIGN		
+ALIGN JUMP_ALIGN
 u_FormatUnsignedDecimalWord:
 	mov		ax, [bp]
@@ -339,8 +338,8 @@
 	mov		ax, [bp]
 	test	ax,ax
-	jnz		u_FormatUnsignedDecimalWord		
+	jnz		u_FormatUnsignedDecimalWord
 	mov		[bp], word g_szDashForZero
 ;;; fall-through
-		
+
 ALIGN JUMP_ALIGN
 s_FormatStringFromSegmentCS:
Index: trunk/Assembly_Library/Src/Display/DisplayFormatCompressed.asm
===================================================================
--- trunk/Assembly_Library/Src/Display/DisplayFormatCompressed.asm	(revision 202)
+++ trunk/Assembly_Library/Src/Display/DisplayFormatCompressed.asm	(revision 223)
@@ -157,6 +157,5 @@
 
 .decode:
-	eSEG	cs
-	lodsb						; load next byte of the string
+	cs lodsb					; load next byte of the string
 
 	mov		ch,al				; save a copy for later processing of high order bits
Index: trunk/Assembly_Library/Src/Display/DisplayPrint.asm
===================================================================
--- trunk/Assembly_Library/Src/Display/DisplayPrint.asm	(revision 202)
+++ trunk/Assembly_Library/Src/Display/DisplayPrint.asm	(revision 223)
@@ -5,5 +5,5 @@
 SECTION .text
 
-				
+
 ;--------------------------------------------------------------------
 ; Supports following formatting types:
@@ -104,7 +104,7 @@
 ;		AX, DX
 ;--------------------------------------------------------------------
-		
+
 %ifndef MODULE_STRINGS_COMPRESSED
-		
+
 ALIGN JUMP_ALIGN
 DisplayPrint_WordFromAXWithBaseInBX:
@@ -126,6 +126,5 @@
 .PrintNextDigit:
 	pop		ax					; Pop digit
-	eSEG	cs
-	xlatb
+	cs xlatb
 	call	DisplayPrint_CharacterFromAL
 	loop	.PrintNextDigit
@@ -152,5 +151,4 @@
 ;--------------------------------------------------------------------
 %ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
-		
 ALIGN JUMP_ALIGN
 DisplayPrint_CharacterBufferFromBXSIwithLengthInCX:
@@ -167,5 +165,4 @@
 	loop	.PrintNextCharacter
 
-	;mov		ds, cx	; Restore DS to BDA. Not needed unless DisplayPrint_CharacterFromAL changes DS.
 	pop		cx
 	pop		si
@@ -173,6 +170,4 @@
 	ret
 %endif
-
-
 
 
@@ -278,6 +273,6 @@
 	pop		cx
 .NothingToRepeat:
-
-	ret
+	ret
+
 
 ;--------------------------------------------------------------------
@@ -292,10 +287,9 @@
 ;		AX, DX
 ;--------------------------------------------------------------------
-
 %ifndef MODULE_STRINGS_COMPRESSED
 ;;;
 ;;; Take care when using this routine with compressed strings (which is why it is disabled).
 ;;; All strings in CSSI should go through the DisplayFormatCompressed code to be decoded.
-;;; 
+;;;
 ALIGN JUMP_ALIGN
 DisplayPrint_NullTerminatedStringFromCSSI:
@@ -304,9 +298,6 @@
 	call	DisplayPrint_NullTerminatedStringFromBXSI
 	pop		bx
-
-	ret
-%endif
-
-		
+	ret
+%endif
 
 
@@ -314,5 +305,5 @@
 ;;; Note that the following routines need to be at the bottom of this file
 ;;; to accomodate short jumps from the next file (DisplayFormat/DisplayFormatCompressed)
-;;; 
+;;;
 
 ;--------------------------------------------------------------------
@@ -329,5 +320,5 @@
 ALIGN JUMP_ALIGN
 DisplayPrint_Newline_FormatAdjustBP:
-	inc		bp					; we didn't need a parameter after all, readjust BP 
+	inc		bp					; we didn't need a parameter after all, readjust BP
 	inc		bp
 	; fall through to DisplayPrint_Newline
@@ -335,5 +326,4 @@
 
 ALIGN JUMP_ALIGN
-		
 DisplayPrint_Newline:
 	mov		al, LF
@@ -364,5 +354,4 @@
 
 
-		
 ;--------------------------------------------------------------------
 ; DisplayPrint_NullTerminatedStringFromBXSI
@@ -396,7 +385,6 @@
 	pop		cx
 	pop		si
-		
-DisplayPrint_Ret:				; random ret to jump to 				
-	ret
-
-
+
+DisplayPrint_Ret:				; random ret to jump to
+	ret
+