Index: /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/EBIOS/AH48h_GetExtendedDriveParameters.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/EBIOS/AH48h_GetExtendedDriveParameters.asm	(revision 228)
+++ /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/EBIOS/AH48h_GetExtendedDriveParameters.asm	(revision 229)
@@ -66,5 +66,5 @@
 	mov		[si+EDRIVE_INFO.qwTotalSectors+2], dx
 	mov		[si+EDRIVE_INFO.qwTotalSectors+4], bx
-	mov		[si+EDRIVE_INFO.qwTotalSectors+6], ax
+	mov		[si+EDRIVE_INFO.qwTotalSectors+6], ax	; Always zero
 	mov		WORD [si+EDRIVE_INFO.wSectorSize], 512
 
Index: unk/XTIDE_Universal_BIOS/Src/Handlers/Int19hLate.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int19hLate.asm	(revision 228)
+++ 	(revision )
@@ -1,39 +1,0 @@
-; Project name	:	XTIDE Universal BIOS
-; Description	:	Late initialization for XT builds.
-
-; Section containing code
-SECTION .text
-
-;--------------------------------------------------------------------
-; Int19hLate_InitializeInt19h
-;	Parameters:
-;		ES:		BDA segment
-;	Returns:
-;		Nothing
-;	Corrupts registers:
-;		BX, SI
-;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
-Int19hLate_InitializeInt19h:
-	mov		bx, BIOS_BOOT_LOADER_INTERRUPT_19h
-	mov		si, HandlerForLateInitialization
-	jmp		Interrupts_InstallHandlerToVectorInBXFromCSSI
-
-
-;--------------------------------------------------------------------
-; HandlerForLateInitialization
-;	Parameters:
-;		Nothing
-;	Returns:
-;		Never returns
-;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
-HandlerForLateInitialization:
-	LOAD_BDA_SEGMENT_TO	es, ax
-	call	Initialize_ShouldSkip			; Skip initialization?
-	jnz		SHORT .SkipInitialization
-	call	Initialize_AndDetectDrives		; Installs boot menu loader
-	int		BIOS_BOOT_LOADER_INTERRUPT_19h
-.SkipInitialization:
-	call	RamVars_Initialize				; RAMVARS must be initialized even for simple boot loader
-	int		BIOS_BOOT_LOADER_INTERRUPT_19h	; Call default system boot loader
Index: /trunk/XTIDE_Universal_BIOS/Src/Initialization/Initialize.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Src/Initialization/Initialize.asm	(revision 228)
+++ /trunk/XTIDE_Universal_BIOS/Src/Initialization/Initialize.asm	(revision 229)
@@ -17,5 +17,5 @@
 ;		Nothing
 ;--------------------------------------------------------------------
-Initialize_FromMainBiosRomSearch:             ; unused entrypoint ok
+Initialize_FromMainBiosRomSearch:			; unused entrypoint ok
 	pushf
 	push	es
@@ -24,12 +24,13 @@
 
 	LOAD_BDA_SEGMENT_TO	es, ax
-	call	Initialize_ShouldSkip
+	sti										; Enable interrupts
+	test	BYTE [es:BDA.bKBFlgs1], (1<<2)	; Clears ZF if CTRL is held down
 	jnz		SHORT .SkipRomInitialization
 
-%ifdef USE_AT	; Early initialization on AT build
-	call	Initialize_AndDetectDrives
-%else			; Late initialization on XT builds
-	call	Int19hLate_InitializeInt19h
-%endif
+	; Install INT 19h handler (boot loader) where drives are detected
+	mov		bx, BIOS_BOOT_LOADER_INTERRUPT_19h
+	mov		si, HandlerForLateInitialization
+	call	Interrupts_InstallHandlerToVectorInBXFromCSSI
+
 .SkipRomInitialization:
 	ePOPA
@@ -41,19 +42,14 @@
 
 ;--------------------------------------------------------------------
-; Checks if user wants to skip ROM initialization.
-;
-; Initialize_ShouldSkip
+; HandlerForLateInitialization
 ;	Parameters:
-;		ES:		BDA segment
+;		Nothing
 ;	Returns:
-;		ZF:		Cleared if ROM initialization is to be skipped
-;				Set to continue ROM initialization
-;	Corrupts registers:
-;		Nothing
+;		Never returns
 ;--------------------------------------------------------------------
-Initialize_ShouldSkip:
-	sti										; Enable interrupts
-	test	BYTE [es:BDA.bKBFlgs1], (1<<2)	; Clear ZF if CTRL is held down
-	ret
+HandlerForLateInitialization:
+	LOAD_BDA_SEGMENT_TO	es, ax
+	call	Initialize_AndDetectDrives		; Installs new boot menu loader
+	int		BIOS_BOOT_LOADER_INTERRUPT_19h	; Display boot menu
 
 
Index: /trunk/XTIDE_Universal_BIOS/Src/Main.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Src/Main.asm	(revision 228)
+++ /trunk/XTIDE_Universal_BIOS/Src/Main.asm	(revision 229)
@@ -182,7 +182,4 @@
 
 	; Boot loader
-%ifndef USE_AT
-	%include "Int19hLate.asm"		; For late initialization
-%endif
 	%include "Int19hMenu.asm"		; For Int 19h, Boot Loader for Boot Menu
 